<script>
import { extent} from "d3-array";
import {scaleLinear, scaleOrdinal, scaleSqrt} from 'd3-scale';
import {axisBottom, axisLeft} from 'd3-axis';
import {schemeDark2} from 'd3-scale-chromatic';
import { select } from 'd3-selection';

  // Dimensions
  const [height, width] = [400, 600];
  const margin = { top: 50, right: 5, bottom: 55, left: 50 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  export let data = [];

  const scalex = scaleLinear().domain(extent(data[0].countries, (d)=> +d.income)).range([0,innerWidth]);
  const scaley = scaleLinear().domain([0,90]).range([innerHeight,0]);
  const scaler = scaleSqrt().domain(extent(data[0].countries, (d)=> +d.population)).range([0,50]);
  const axisx = axisBottom(scalex).ticks().tickFormat(function(d){return '$' + (d)});
  const axisy = axisLeft(scaley).ticks();
  const xaxis = function(){
    return axisx(select('g.xaxis'))
  };
  const yaxis = function(){return axisy(select('g.yaxis'))}
  const colourscale = scaleOrdinal().domain([]).range(schemeDark2)
  
</script>

<svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform="translate({margin.left+20}, 0)">
    <!--  -->
    {#each data as point}
      {#each point.countries as cr}
        <circle cx={scalex(+cr.income)} cy={scaley(+cr.life_exp)} 
                r= {scaler(+cr.population)}
                style = {'fill:' + colourscale(cr.continent)}
                
                />
      {/each}
    {/each}
    <g font-size="15" font-family="sans-serif" text-anchor="end">
      <text x="{width/2}" y='380' >GDP per Capita</text>
    </g>
    <g transform="rotate(-90)" font-size="15" font-family="sans-serif" text-anchor="end">
      <text x="-120" y="-55" >Life Expectancy</text>
    </g>
    <g font-size='30' font-family='sans-serif' text-anchor='end'>
      <text x="410" y={margin.top}>Gapminder Scatterplot</text>
    </g>
    <g font-size="30" font-family="sans-serif" text-anchor="end" opacity=0.5 color='grey'>
      <text x="510" y="320" >1800</text>
    </g>
    <g class='xaxis' transform='translate(-30,330)'  use:xaxis></g>
    <g class='yaxis' transform={`translate(-30,35)`} use:yaxis></g>
  </g>
  
	

</svg>
